//+------------------------------------------------------------------+
//|                                           .mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 MediumBlue
//---- input parameters
extern int       nn=21;
//---- buffers
double Line[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators 
SetIndexStyle(0,DRAW_LINE);
    SetIndexBuffer(0,Line);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
  double barr, as, bs,cs,ds,e, f,k, LR;
int n,n1;
//   
for (barr=0;barr<=50;barr++){
	for (n=1;n<=nn;n++){
		n1=barr+n-1;
as=as+MathLog(n);
bs=bs+MathLog(Close[n1]);
cs=cs+MathLog(n)* MathLog(Close[n1]);
ds=ds+MathPow(MathLog(n),2);
}
e=(as*bs-nn*cs)/(as*as-nn*ds);
f=MathExp((bs-e*as)/nn);
                                                                                                                                                                                                                                   
LR = f*MathPow(nn,e);
	as=0;                                                 
	bs=0;
	cs=0;
	ds=0;
	Line[n]=LR;
}
//----
   return(0);
  }
//+------------------------------------------------------------------+